/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator;

/**
 *
 * @author simone
 */
public class CalculatorThread extends Thread {
    private Calculator calculator;
    private String expression;
    private AsynchronousOutput postponedOutput;

    public CalculatorThread(Calculator calculator, String expression, AsynchronousOutput postponedOutput) {
        this.calculator = calculator;
        this.expression = expression;
        this.postponedOutput = postponedOutput;
        start ();
    }

    @Override
    public void run() {
        int newlineindex;
        while ((newlineindex = expression.indexOf("\n")) != -1) {
            postponedOutput.printOutput("Expression"+calculator.getStep()+"> "+expression.substring(0, newlineindex)+"\n","regular");
            postponedOutput.printOutput(calculator.compute(expression.substring(0, newlineindex))+"\n\n", "bold");
            if (++newlineindex >= expression.length()) return;
            expression = expression.substring(newlineindex);
        }
        postponedOutput.printOutput("Expression"+calculator.getStep()+"> "+expression+"\n","regular");
        postponedOutput.printOutput(calculator.compute(expression)+"\n\n","bold");
    }

    public void stopCalculus () {
        if (calculator != null) calculator.stopCalculus ();
    }
}
