/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.arithmetic;

import engcalculator.function.infix.*;
import engcalculator.data.Interval;
import engcalculator.function.prefix.interval.Invert;

/**
 *
 * @author simone
 */
public class Div extends DualInputSingleOutputInfixFunction {
    private final static Invert INVERT = new Invert ();
    private final static Mul MUL = new Mul();
    private final static String[] EXAMPLE_LEFT = {"6_9"};
    private final static String[] EXAMPLE_RIGHT = {"1_3"};
    private final static String[] RESULT = {"2_9"};

    public Div() {
        super ("/", true, true, "a / b divides a by b. b interval should not contain the 0.", EXAMPLE_LEFT,  EXAMPLE_RIGHT, RESULT);
    }

    @Override
    public Interval _computeIntervals(Interval left, Interval right) throws Exception {
//        right = new IntervalList(right);
//        right.set(0, INVERT._compute(right.subList(0, 1)).getLeft());
        return MUL._computeIntervals(left, INVERT._computeIntervals(right));

    }
}
