/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.square;

import engcalculator.data.Interval;
import engcalculator.function.CalculusException;
import engcalculator.function.prefix.SingleInputSingleOutputPrefixFunction;

/**
 *
 * @author simone
 */
public class SquareRoot extends SingleInputSingleOutputPrefixFunction {
    private final static String[] RESULT = {"0_10,5_7"};
    private final static String[] EXAMPLE = {"0_100, 25_49"};

    public SquareRoot() {
        super ("sqrt", true, true, "sqrt a - square root the interval a. a should not contain negative values. Extended to directed intervals.", EXAMPLE, RESULT);
    }

    public Interval  _computeIntervals (Interval a) throws Exception {
        if (! a.isPositive()) throw new CalculusException ("It is not possible to compute square root of a negative number");
        return new Interval (Math.sqrt(a.getLeft()), Math.sqrt(a.getRight()));
    }

}
