/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.statistic;

import engcalculator.function.infix.compare.Smaller;
import engcalculator.data.IntervalList;
import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public class Min extends PrefixFunction {
    private final static Smaller SMALLER = new Smaller();

    private final static String[] EXAMPLE = {"1_2, 4_5, 6_7"};
    private final static String[] RESULT = {"1_2"};


    public Min() {
        super ("min", (byte) -1, false, true, "min returns the minimum interval of a list of intervals.", EXAMPLE, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        int i,j;
        final int s = input.size();
        for (i=0; i<s; ++i) {
            for (j=0; j<s; ++j) {
                if (i==j) continue;
                if (SMALLER.compare(input.get(i), input.get(j))) continue;
                break;
            }
            if (j == s) return new IntervalList (input.get (i));
        }
        throw new UnsupportedOperationException("It is not possible to find a maximum value because some intervals are overlapped");
    }
}
