/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.system;

import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.data.Literal;
import engcalculator.function.infix.compare.NotEqual;
import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public class PrintMode extends PrefixFunction {
    private final static NotEqual notEqual = new NotEqual();
    private final static Interval ZERO = new Interval (0);

    public PrintMode() {
        super("printmode", (byte) 4, false, true, "Set the interval print mode. Syntax: printmode (0 to print min_max (otherwise to print val%tol), 0 to print scientific notation (otherwise to print engineer format), decimal digits used in engineer notation mode, the minimum number of spaces used for spacing in list and matrix).", null, null);
    }


    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        Interval.setValTolFormat(notEqual.compare(input.get(0), ZERO), notEqual.compare(input.get(1), ZERO), (int) input.get(2).getVal(), (int) input.get(3).getVal());
        return new IntervalList (new Literal(("Done")));
    }

}
