/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.data;

/**
 *
 * @author simone
 */
public class NamedMatrixIntervalList extends MatrixIntervalList {
    private String name;

    public NamedMatrixIntervalList (String name) {
       this.name = name;
    }

    public NamedMatrixIntervalList (Interval i, String name) {
       add (i);
       this.name = name;
    }

    public NamedMatrixIntervalList (IntervalList i, String name) {
       super (i);
       this.name = name;
    }

    public NamedMatrixIntervalList (MatrixIntervalList i, String name) {
       super (i);
       this.name = name;
    }

   public NamedMatrixIntervalList (NamedMatrixIntervalList i) {
       super (i);
       this.name = i.name;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public String toString () {
        if (size() >0 ) {
            if (name != null) return new StringBuffer(name).append(" = ").append(super.toString()).toString();
            else return super.toString();
        } 
        else return name;
    }
}
