/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix;

import engcalculator.function.infix.InfixFunction;
import engcalculator.data.Interval;
import engcalculator.data.IntervalList;

/**
 *
 * @author simone
 */
public abstract class DualInputSingleOutputInfixFunction extends InfixFunction {

    public DualInputSingleOutputInfixFunction(String name, boolean expandsScalarInput, boolean constant, String help, String[] examplesLeft, String[] examplesRight, String[] results) {
        super(name, (byte) 1, (byte) 1, expandsScalarInput, constant, help, examplesLeft, examplesRight, results);
    }

    @Override
    public final IntervalList _compute (IntervalList leftSide, IntervalList rightSide) throws Exception {
        return new IntervalList (_computeIntervals(leftSide.getFirst(), rightSide.getFirst()));
    }

    public abstract Interval _computeIntervals (Interval leftSide, Interval rightSide) throws Exception;

}
