/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.set;

import engcalculator.data.Interval;
import engcalculator.function.infix.DualInputSingleOutputInfixFunction;


/**
 *
 * @author simone
 */
public class Intersection extends DualInputSingleOutputInfixFunction {
    private final static String[] EXAMPLE_LEFT = {"6_7","5_7", "1_2", "3_4"};
    private final static String[] EXAMPLE_RIGHT = {"4_5","4_6", "2_4", "-3_-2"};
    private final static String[] RESULT = {"6_5","5_6","2","3_-2"};

    public Intersection() {
        super("&", true, true, "& returns the intersection between two intervals. If the two intervals have no intersection it returns an empty interval.", EXAMPLE_LEFT, EXAMPLE_RIGHT, RESULT);
    }

    @Override
    public Interval _computeIntervals (Interval ls, Interval rs) throws Exception {
        return new Interval (Math.max(ls.getLeft(), rs.getLeft()), Math.min(ls.getRight(), rs.getRight()));
    }

}
