/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.interval;

import engcalculator.data.Interval;
import engcalculator.function.prefix.SingleInputSingleOutputPrefixFunction;

/**
 *
 * @author simone
 */
public class Module extends SingleInputSingleOutputPrefixFunction {
    private final static String[] EXAMPLE = {"-10_10", "-10_-5", "10_15", "10_-10", "-5_-10", "15_10"};
    private final static String[] RESULT = {"10", "10", "15", "10", "10", "15"};

    public Module() {
        super("module", true, true, "Compute the module of an interval, which is a real value. The interval module is defined as the maximum of the absolute value of the extremes.", EXAMPLE , RESULT);
    }
    
    @Override
    public Interval _computeIntervals (Interval input) throws Exception {
        return new Interval (Math.max(Math.abs(input.getLeft()), Math.abs(input.getRight()))).setOuter();
    }
}
