/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.matrix;

import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.data.MatrixIntervalList;
import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public class MatrixDiagonal extends PrefixFunction {
    private final static String[] EXAMPLE = {"1,2"};
    private final static String[] RESULT = {"(1,0,0,2)#2"};

    public MatrixDiagonal() {
        super("diagonal", (byte) -1, false, true, "Build an diagonal matrix with given list.", EXAMPLE, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList input) throws Exception {
        final int cs = (int) input.size();
        MatrixIntervalList result = new MatrixIntervalList (cs);
        int i = 0;
        for (int c=0; c<cs; ++c)
            for (int r=0; r<cs; ++r)
                if (r == c) result.add(input.get(i++));
                else result.add(new Interval(0));
        return result;

    }

}
