/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.system;

import engcalculator.data.Interval;
import engcalculator.data.Literal;
import engcalculator.function.prefix.SingleInputSingleOutputPrefixFunction;

/**
 *
 * @author simone
 */
public class OuterExtimation extends SingleInputSingleOutputPrefixFunction {

    public OuterExtimation() {
        super("outerextimation", false, true, "If the argument of this function is != from 0, every calculus involving an interval (NOT scalar) will be outer extimated in order to be sure to cover every result. By default this option is disabled.", null, null);
    }

    @Override
    public Interval _computeIntervals(Interval input) throws Exception {
        if (input.getLeft() == 0 && input.getRight() == 0) {
            Interval.setAvoidOuterExtimation(false);
            return new Literal ("Outer Extimation Disabled");
        }
        Interval.setAvoidOuterExtimation(true);
        return new Literal ("Outer Extimation Enabled");        
    }

}
